Subject: [Cbor] Roman Danyliw's No Objection on draft-ietf-cbor-cddl-control-06: (with COMMENT)

From: Roman Danyliw via Datatracker <[email-masked]>
Date: Wed, 20 Oct 2021 07:05:41 -0700

Roman Danyliw has entered the following ballot position for
draft-ietf-cbor-cddl-control-06: No Objection

When responding, please keep the subject line intact and reply to all
email addresses included in the To and CC lines. (Feel free to cut this
introductory paragraph, however.)

Please refer to https://www.ietf.org/blog/handling-iesg-ballot-positions/
for more information about how to handle DISCUSS and COMMENT positions.

The document, along with other ballot positions, can be found here:
https://datatracker.ietf.org/doc/draft-ietf-cbor-cddl-control/

----------------------------------------------------------------------
COMMENT:
----------------------------------------------------------------------

** Section 2.2.  Checking my understanding of string concatenation:

(a) “Target and controller MUST be strings”

(b) “If the target is a text string, the result of that concatenation MUST be
valid UTF-8”.

There is a distinction being made between a “text string” and “byte string” per
Section 3.1 of RFC8610?

---

From: Carsten Bormann <[email-masked]>
Date: Wed, 20 Oct 2021 17:05:35 +0200

Hi Roman,

In the context of CDDL we do distinguish between text strings and byte strings (inherited from CBOR, which pretty much started to exist when we couldn’t get that distinction cleanly introduced into msgpack in 2012).

Maybe we can honor POLA (*) by not using “strings” to refer to the type union of either, while keeping the reader unsuspecting.

Now https://github.com/cbor-wg/cddl-control/pull/12

Grüße, Carsten

(*) https://en.wikipedia.org/wiki/Principle_of_least_astonishment
(not https://en.wikipedia.org/wiki/Principle_of_least_privilege :-)

---

From: Roman Danyliw <[email-masked]>
Date: Wed, 20 Oct 2021 15:35:04 +0000

Hi Carsten!

> -----Original Message-----
> From: Carsten Bormann <[email-masked]>
> Sent: Wednesday, October 20, 2021 11:06 AM
> To: Roman Danyliw <[email-masked]>
> Cc: The IESG <[email-masked]>; [email-masked]; cbor-
> [email-masked]; [email-masked]; Christian Amsüss <[email-masked]>
> Subject: Re: Roman Danyliw's No Objection on draft-ietf-cbor-cddl-control-06:
> (with COMMENT)
> 
> Hi Roman,
> 
> > (b) “If the target is a text string, the result of that concatenation
> > MUST be valid UTF-8”.
> >
> > There is a distinction being made between a “text string” and “byte
> > string” per Section 3.1 of RFC8610?
> 
> In the context of CDDL we do distinguish between text strings and byte strings
> (inherited from CBOR, which pretty much started to exist when we couldn’t get
> that distinction cleanly introduced into msgpack in 2012).
> 
> Maybe we can honor POLA (*) by not using “strings” to refer to the type union
> of either, while keeping the reader unsuspecting.
> 

Thanks for explaining.  The edits in the pull request makes is clear.  

Much appreciated,
Roman